package cn.iocoder.yudao.module.member.service.alloc;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.member.controller.admin.alloc.vo.AllocPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.alloc.vo.AllocSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.alloc.AllocDO;
import cn.iocoder.yudao.module.member.dal.mysql.alloc.AllocMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.member.enums.ErrorCodeConstants.ALLOC_NOT_EXISTS;

/**
 * 配置 Service 实现类
 *
 * @author 开发账号
 */
@Service
@Validated
public class AllocServiceImpl implements AllocService {

    @Resource
    private AllocMapper allocMapper;

    @Override
    public Long createAlloc(AllocSaveReqVO createReqVO) {
        // 插入
        AllocDO alloc = BeanUtils.toBean(createReqVO, AllocDO.class);
        allocMapper.insert(alloc);
        // 返回
        return alloc.getId();
    }

    @Override
    public void updateAlloc(AllocSaveReqVO updateReqVO) {
        // 校验存在
        validateAllocExists(updateReqVO.getId());
        // 更新
        AllocDO updateObj = BeanUtils.toBean(updateReqVO, AllocDO.class);
        allocMapper.updateById(updateObj);
    }

    @Override
    public void deleteAlloc(Long id) {
        // 校验存在
        validateAllocExists(id);
        // 删除
        allocMapper.deleteById(id);
    }

    private void validateAllocExists(Long id) {
        if (allocMapper.selectById(id) == null) {
            throw exception(ALLOC_NOT_EXISTS);
        }
    }

    @Override
    public AllocDO getAlloc(Long id) {
        return allocMapper.selectById(id);
    }

    @Override
    public PageResult<AllocDO> getAllocPage(AllocPageReqVO pageReqVO) {
        return allocMapper.selectPage(pageReqVO);
    }

    @Override
    public List<AllocDO> getAllocList() {
        List<AllocDO> allocDOS = allocMapper.selectList(Wrappers.<AllocDO>lambdaQuery().eq(AllocDO::getMoudle, "1"));
        return allocDOS;
    }
}